package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * It is required when protoType is dynamic
 */
@ApiModel(description = "It is required when protoType is dynamic")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class Ipv6DynamicOpenApiVo   {
  @JsonProperty("getIpv6Type")
  private Integer getIpv6Type;

  @JsonProperty("prefixEnable")
  private Boolean prefixEnable;

  @JsonProperty("prefixSize")
  private Integer prefixSize;

  @JsonProperty("dnsType")
  private Integer dnsType;

  @JsonProperty("primaryDns")
  private String primaryDns;

  @JsonProperty("secondaryDns")
  private String secondaryDns;

  public Ipv6DynamicOpenApiVo getIpv6Type(Integer getIpv6Type) {
    this.getIpv6Type = getIpv6Type;
    return this;
  }

  /**
   * It should be a value as follows: 0: SLAAC; 1: DHCPv6; 2: specified; 3: auto; 4:non-address.
   * @return getIpv6Type
  */
  @ApiModelProperty(required = true, value = "It should be a value as follows: 0: SLAAC; 1: DHCPv6; 2: specified; 3: auto; 4:non-address.")
  @NotNull


  public Integer getGetIpv6Type() {
    return getIpv6Type;
  }

  public void setGetIpv6Type(Integer getIpv6Type) {
    this.getIpv6Type = getIpv6Type;
  }

  public Ipv6DynamicOpenApiVo prefixEnable(Boolean prefixEnable) {
    this.prefixEnable = prefixEnable;
    return this;
  }

  /**
   * Get prefixEnable
   * @return prefixEnable
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull


  public Boolean getPrefixEnable() {
    return prefixEnable;
  }

  public void setPrefixEnable(Boolean prefixEnable) {
    this.prefixEnable = prefixEnable;
  }

  public Ipv6DynamicOpenApiVo prefixSize(Integer prefixSize) {
    this.prefixSize = prefixSize;
    return this;
  }

  /**
   * It is required when [prefixEnable] is true, which ranges from 48 ~ 64.
   * @return prefixSize
  */
  @ApiModelProperty(value = "It is required when [prefixEnable] is true, which ranges from 48 ~ 64.")


  public Integer getPrefixSize() {
    return prefixSize;
  }

  public void setPrefixSize(Integer prefixSize) {
    this.prefixSize = prefixSize;
  }

  public Ipv6DynamicOpenApiVo dnsType(Integer dnsType) {
    this.dnsType = dnsType;
    return this;
  }

  /**
   * DNS Address Type, 0: dynamic, 1: static.
   * @return dnsType
  */
  @ApiModelProperty(required = true, value = "DNS Address Type, 0: dynamic, 1: static.")
  @NotNull


  public Integer getDnsType() {
    return dnsType;
  }

  public void setDnsType(Integer dnsType) {
    this.dnsType = dnsType;
  }

  public Ipv6DynamicOpenApiVo primaryDns(String primaryDns) {
    this.primaryDns = primaryDns;
    return this;
  }

  /**
   * It is required when [dnsType] is 1.
   * @return primaryDns
  */
  @ApiModelProperty(value = "It is required when [dnsType] is 1.")


  public String getPrimaryDns() {
    return primaryDns;
  }

  public void setPrimaryDns(String primaryDns) {
    this.primaryDns = primaryDns;
  }

  public Ipv6DynamicOpenApiVo secondaryDns(String secondaryDns) {
    this.secondaryDns = secondaryDns;
    return this;
  }

  /**
   * It takes effect when [dnsType] is 1
   * @return secondaryDns
  */
  @ApiModelProperty(value = "It takes effect when [dnsType] is 1")


  public String getSecondaryDns() {
    return secondaryDns;
  }

  public void setSecondaryDns(String secondaryDns) {
    this.secondaryDns = secondaryDns;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Ipv6DynamicOpenApiVo ipv6DynamicOpenApiVo = (Ipv6DynamicOpenApiVo) o;
    return Objects.equals(this.getIpv6Type, ipv6DynamicOpenApiVo.getIpv6Type) &&
        Objects.equals(this.prefixEnable, ipv6DynamicOpenApiVo.prefixEnable) &&
        Objects.equals(this.prefixSize, ipv6DynamicOpenApiVo.prefixSize) &&
        Objects.equals(this.dnsType, ipv6DynamicOpenApiVo.dnsType) &&
        Objects.equals(this.primaryDns, ipv6DynamicOpenApiVo.primaryDns) &&
        Objects.equals(this.secondaryDns, ipv6DynamicOpenApiVo.secondaryDns);
  }

  @Override
  public int hashCode() {
    return Objects.hash(getIpv6Type, prefixEnable, prefixSize, dnsType, primaryDns, secondaryDns);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Ipv6DynamicOpenApiVo {\n");
    
    sb.append("    getIpv6Type: ").append(toIndentedString(getIpv6Type)).append("\n");
    sb.append("    prefixEnable: ").append(toIndentedString(prefixEnable)).append("\n");
    sb.append("    prefixSize: ").append(toIndentedString(prefixSize)).append("\n");
    sb.append("    dnsType: ").append(toIndentedString(dnsType)).append("\n");
    sb.append("    primaryDns: ").append(toIndentedString(primaryDns)).append("\n");
    sb.append("    secondaryDns: ").append(toIndentedString(secondaryDns)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

